<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 30/08/13
 * Time: 19:21
 * To change this template use File | Settings | File Templates.
 */

namespace Importacao\Logic\Util;


class BarraProgressoCli {

    private $startTime;
    private $timeElapsed;
    private $taskName;
    private $total;
    private $step;
    private $size;
    private $hasFinished;

    public function __construct($taskName, $total, $step = 7, $size = 50) {
        $this->startTime = time();
        $this->timeElapsed = 0;
        $this->taskName = $taskName;
        $this->total = $total;
        $this->step = $step;
        $this->size = $size;
        $this->hasFinished = false;
    }

    public function showStatus($done, $verifyStep = true)
    {
        // if we go over our bound, just ignore it
        if ($done > $this->total) {
            $this->finish();
            return "Arquivo gerado com sucesso.";
        }
        if ($done == 0) $done = 1;

        $now  = time();
        $perc = (double)($done / $this->total);
        $bar  = floor($perc * $this->size);

        $status_bar  = "\r( {$this->taskName} )[";
        $status_bar .= str_repeat("=", $bar);

        if ($bar < $this->size) {
            $status_bar .= ">";
            $status_bar .= str_repeat(" ", $this->size - $bar);
        } else {
            $status_bar .= "=";
        }

        $disp = number_format($perc*100, 0);

        $status_bar .= "] $disp%  $done/$this->total";

        $rate = ($now-$this->startTime)/$done;
        $left = $this->total - $done;
        $eta  = round($rate * $left, 2);

        $this->timeElapsed = $now - $this->startTime;
        if ($verifyStep && (($this->timeElapsed % $this->step) != 0)) {
            return;
        }

        $status_bar .= " Falta: ".number_format($eta)." sec.  Passou: ".number_format($this->timeElapsed/60)." sec.";
//        echo str_repeat("\r", 4096 - strlen($status_bar))."$status_bar";

        flush();

        // when done, send a newline
        if ($done == $this->total) {
            $this->hasFinished = true;
            echo "\n";
        }

        return "Gerando Arquivo SQL: ".$disp."% - $done/$this->total -- Falta: ".number_format($eta)." sec.  Passou: ".     number_format($this->timeElapsed/60)." sec.";

    }

    public function finish() {
        if (!$this->hasFinished) {
            $this->showStatus($this->total, false);
        }
    }

}